
#include <mql4-http.mqh>


input double TakeProfit    =3000;
input double Threshold = 0;
input double StopLoss = 1000;
input double Lots          =1;
input bool Learnmode = false;
input string brainid = "3daysREADONLY";
input double activationThreshold = 0.60;


void OnTick(void)
  {
   static datetime Time0;
   if (Time0 == Time[0]) return; Time0 = Time[0];

   
   int    cnt,ticket,total;

   double sl = TakeProfit;
   double TrailingStop  = StopLoss;

   if(Bars<100)
     {
      Print("bars less than 100");
      return;
     }
   if(TakeProfit<10)
     {
      Print("TakeProfit less than 10");
      return;
     }


   int m1,m2,m3;
 
   
   m1 = MathRound(((iOpen(NULL,0,0)-iOpen(NULL,0,1)))*1500);
   m2 = MathRound((iOpen(NULL,0,1)-iOpen(NULL,0,2))*1500);
   m3 = MathRound(((iOpen(NULL,0,2)-iOpen(NULL,0,3)))*1500);
   
   if (m1>2) m1 = 2;else if (m1>1) m1 = 1;else if (m1<-2) m1 = -2;else if (m1<-1) m1 = -1;
   if (m2>2) m2 = 2;else if (m2>1) m2 = 1;else if (m2<-2) m2 = -2;else if (m2<-1) m2 = -1;
   if (m3>2) m3 = 2;else if (m3>1) m3 = 1;else if (m3<-2) m3 = -2;else if (m3<-1) m3 = -1;
   
   string result;
   int res[30];
   int k = 0;


   string url="http://ml.vanillatech.de/api.php?query={token:'" + brainid + "',activationThreshold:" + activationThreshold + ",learnmode:";
   if (Learnmode) {
      url += "true,outputLMT:";
      if (Bars%3==0) url += "20,"; else url+="0,";
      url += "input:[" + m1+ "]}";
      result = httpGET(url);
   } else {
      url += "false,outputLMT:";
      string url1 = url + "20,input:[" + m1+ "]}";
      string url2 = url + "0,input:[" + m2+ "]}";
      string url3 = url + "0,input:[" + m3+ "]}";
   
      //result = httpGET(url3);
      result = httpGET(url2);
      result = httpGET(url1);
   }
  
   if(result != "")
     {
      
      string outp[];
      k = StringSplit(result,StringGetCharacter(",",0),outp);
      
      for (int c=0;c<k;c++) {
         res[c] = StrToInteger(outp[c]);
      }
      Print("Input: " + m3 + " - " + m2 + " - " + m1 + " AI prediction: " + res[0] + " - " + res[1] + " - " + res[2]);
     }
   
   total=OrdersTotal();
   double l = Lots;
   int e = 20;
   
   
      for(cnt=0;cnt<total;cnt++)
     {
      if(!OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES))
         continue;
      if(OrderType()<=OP_SELL &&   // check for opened position 
         OrderSymbol()==Symbol())  // check for symbol
        {
         //--- long position is opened
         if(OrderType()==OP_BUY)
           {
            //--- should it be closed?
            if (res[0]<=Threshold)
            {
             
               //--- close order and exit
               if(!OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet))
                  Print("OrderClose error ",GetLastError());
               return;
              }
            //--- check for trailing stop
            if(TrailingStop>0)
              {
               if(Bid-OrderOpenPrice()>Point*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-Point*TrailingStop)
                    {
                     //--- modify order and exit
                     if(!OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green))
                        Print("OrderModify error ",GetLastError());
                     return;
                    }
                 }
              }
           }
         else // go to short position
           {
            
            if ( res[0]>=-Threshold)
            {
            
              
               //--- close order and exit
               if(!OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet))
                  Print("OrderClose error ",GetLastError());
               return;
              }}
            //--- check for trailing stop
            if(TrailingStop>0)
              {
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                 {
                  if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                    {
                     //--- modify order and exit
                     if(!OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red))
                        Print("OrderModify error ",GetLastError());
                     return;
                    }
                 }
              }
           
           
           }
       
     }
   
   
   
   if(total<1)
     {
      //--- no opened orders identified
      if(AccountFreeMargin()<(1000*Lots))
        {
         Print("We have no money. Free Margin = ",AccountFreeMargin());
         return;
        }
        
      //--- check for long position (BUY) possibility
      
        if (res[0] >Threshold)
        {
        
            
         ticket=OrderSend(Symbol(),OP_BUY,l,Ask,3,Bid-TrailingStop*Point,Ask+sl*Point,"macd sample",16384,0,Green);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
               Print("BUY order opened : ",OrderOpenPrice());
           }
         else
            Print("Error opening BUY order : ",GetLastError());
         return;
        }

      //--- check for short position (SELL) possibility
      

      
        if ( res[0] <-Threshold)
        {
           
         ticket=OrderSend(Symbol(),OP_SELL,l,Bid,3,Ask+TrailingStop*Point,Bid-sl*Point,"macd sample",16384,0,Red);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
               Print("SELL order opened : ",OrderOpenPrice());
           }
         else
            Print("Error opening SELL order : ",GetLastError());
        
      //--- exit from the "no opened orders" block
      return;
      }

     }

  }

